package ru.landgrafhomyak.serdha.api.v0.ddl.table

import ru.landgrafhomyak.serdha.api.v0.Expression
import ru.landgrafhomyak.serdha.api.v0.ddl.types.ColumnType


public interface TableUpdater<TableNewUserExtension : Any, TableOldUserExtension : Any> : TableCreator<TableNewUserExtension> {
	public val oldExpressionBuilder: Expression.Builder<TableOldUserExtension>

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> keepColumn(c: Column<RuntimeType, DatabaseType, TableOldUserExtension>): Column<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> renameAndKeepColumn(c: Column<RuntimeType, DatabaseType, TableOldUserExtension>, newName: String): Column<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> mapAndKeepColumn(c: Column<*, *, TableOldUserExtension>, newValue: Expression<RuntimeType, DatabaseType, TableOldUserExtension>, where: Expression<Boolean, ColumnType.BOOLEAN, TableNewUserExtension>?): Column<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> mapAndKeepColumn(c: Column<*, *, TableOldUserExtension>, newValue: Expression<RuntimeType, DatabaseType, TableOldUserExtension>): Column<RuntimeType, DatabaseType, TableNewUserExtension> = this.mapAndKeepColumn(c, newValue, null)
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> mapAndRenameAndKeepColumn(c: Column<*, *, TableOldUserExtension>, newName: String, newValue: Expression<RuntimeType, DatabaseType, TableOldUserExtension>, where: Expression<Boolean, ColumnType.BOOLEAN, TableNewUserExtension>?): Column<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> mapAndRenameAndKeepColumn(c: Column<*, *, TableOldUserExtension>, newName: String, newValue: Expression<RuntimeType, DatabaseType, TableOldUserExtension>): Column<RuntimeType, DatabaseType, TableNewUserExtension> = this.mapAndRenameAndKeepColumn(c, newName, newValue, null)
	public fun deleteColumn(c: Column<*, *, TableOldUserExtension>)

	public fun keepIndex(i: Index<TableOldUserExtension>): Index<TableNewUserExtension>
	public fun renameAndKeepIndex(i: Index<TableOldUserExtension>, newName: String): Index<TableNewUserExtension>
	public fun deleteIndex(i: Index<TableOldUserExtension>)

	public fun keepCheck(i: CheckConstraint<TableOldUserExtension>): CheckConstraint<TableNewUserExtension>
	public fun renameAndKeepCheck(i: CheckConstraint<TableOldUserExtension>, newName: String): CheckConstraint<TableNewUserExtension>
	public fun deleteCheck(i: CheckConstraint<TableOldUserExtension>)

	public fun keepUniqueIndex(i: UniqueIndex<TableOldUserExtension>): UniqueIndex<TableNewUserExtension>
	public fun renameAndKeepUniqueIndex(i: UniqueIndex<TableOldUserExtension>, newName: String): UniqueIndex<TableNewUserExtension>
	public fun deleteUniqueIndex(i: UniqueIndex<TableOldUserExtension>)

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> keepDefaultValue(c: Column<RuntimeType, DatabaseType, TableNewUserExtension>, d: DefaultConstraint<RuntimeType, DatabaseType, TableOldUserExtension>): DefaultConstraint<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> changeDefaultValue(c: Column<RuntimeType, DatabaseType, TableNewUserExtension>, d: DefaultConstraint<*, *, TableOldUserExtension>): DefaultConstraint<RuntimeType, DatabaseType, TableNewUserExtension>
	public fun deleteDefaultValue(i: DefaultConstraint<*, *, TableOldUserExtension>)

	public fun <TargetTableUserWrapper : Any> keepForeignRowReference(
		frr: ForeignRowReference<TableOldUserExtension, TargetTableUserWrapper>,
		onDelete: ForeignRowReference.OnDeleteAction? = null
	): ForeignRowReference<TableNewUserExtension, TargetTableUserWrapper>

	public fun <TargetTableOldUserWrapper : Any, TargetTableNewUserWrapper : Any> keepForeignRowReferenceToUpdatedTable(
		frr: ForeignRowReference<TableOldUserExtension, TargetTableOldUserWrapper>,
		updatedTable: Table<TargetTableNewUserWrapper, TargetTableOldUserWrapper>,
		onDelete: ForeignRowReference.OnDeleteAction? = null
	): ForeignRowReference<TableNewUserExtension, TargetTableNewUserWrapper>

	public fun <TargetTableUserWrapper : Any> renameAndKeepForeignRowReference(
		frr: ForeignRowReference<TableOldUserExtension, TargetTableUserWrapper>,
		onDelete: ForeignRowReference.OnDeleteAction? = null
	): ForeignRowReference<TableNewUserExtension, TargetTableUserWrapper>


	public fun <TargetTableOldUserWrapper : Any, TargetTableNewUserWrapper : Any> renameAndKeepForeignRowReferenceToUpdatedTable(
		frr: ForeignRowReference<TableOldUserExtension, TargetTableOldUserWrapper>,
		updatedTable: Table<TargetTableNewUserWrapper, TargetTableOldUserWrapper>,
		onDelete: ForeignRowReference.OnDeleteAction? = null
	): ForeignRowReference<TableNewUserExtension, TargetTableNewUserWrapper>

	public fun deleteForeignRowReference(frr: ForeignRowReference<TableOldUserExtension, *>)
}